﻿using System;
using System.Collections.Generic;
using System.Text;

namespace TTT
{
    class Utilities
    {
        public class LazyLoader<T>
        {
            public delegate T LazyLoaderDelegate();
            private bool? isInit = null;
            private T _value;
            private LazyLoaderDelegate _valueCalculator;

            public LazyLoader(LazyLoaderDelegate valueCalculator)
            {
                _valueCalculator = valueCalculator;
            }

            public T Value
            {
                get
                {
                    if (isInit != true)
                    {
                        _value = _valueCalculator();
                        isInit = true;
                    }
                    return _value;
                }
                set
                {
                    _value = value;
                    isInit = true;
                }
            }

            public void Clear()
            {
                isInit = false;
            }

        }


        public static double DegreeToRadian(double angle)
        {
            return Math.PI * angle / 180.0;
        }



        public static double RadianToDegree(double angle)
        {
            return angle * 180.0 / Math.PI;
            //radians * 180.0 / PI
        }

    }
}
